
*=$1500
; MOS/ OSI CHECKSUM LOADER
;
;The MOS Technology format 
;The Lines
;Each line consists of 5 fields. These are the length field, address field, data field, 
;and the checksum. The lines always start with a semicolon (;) character.
;
;The Fields
;    ___ ________ _________ ______ __________ ______
;   |_;_|_Length_|_Address_|_Data_|_Checksum_|_CRLF_|
;	
;
;Length
;The record length field is a 2 character (1 byte) field that specifies the number of 
;data bytes in the record. Typically this is 24 or less.
;	
;
;Address
;This is a 2-byte address that specifies where the data in the record is to be loaded 
;into memory, big-endian.
;
;
;Data
;The data field contains the executable code, memory-loadable data or descriptive 
;information to be transferred.
;
;Checksum
;The checksum is an 2-byte field that represents the least significant two bytes of 
;the the sum of the values represented by the pairs of characters making up the record’s 
;length, address, and data fields, big-endian.
;
;End of File	(optional?)
;The final line should have a data length of zero, and the count of data lines in 
;the address field. The checksum is not the usual checksum, it is instead a repeat 
;of the data line count.

;OSI specific
;The final line consists of a $ character followed by 4 digit hex address to start execution
;


OUTCHR = $FFEE
INCHR  = $FFEB
STOR =*                     
		.BYTE 0,0,0,0,0
START               JSR LOADON
                    CMP #$3B	;START OF LINE CHAR
                    BEQ RDCHK
                    CMP #'$
                    BNE START
                    JSR GETHEX
                    STA STOR+3
                    JSR GETHEX
                    STA STOR+2
                    JMP EXEC
                    
RDCHK               LDA #$00
                    STA STOR+2
                    STA STOR+3   ;INIT CHKSUM
                    JSR ADDCHK
                    TAX
                    JSR ADDCHK
                    STA ADDRHI
                    JSR ADDCHK
                    STA ADDRLO
STORIT              JSR ADDCHK
ADDRLO =*+1
ADDRHI =*+2
                    STA $ADDE
                    INC ADDRLO
                    BNE NOINC
                    INC ADDRHI
NOINC               DEX
                    BNE STORIT
                    JSR GETHEX
                    CMP STOR+3
                    BNE PRINT
                    JSR GETHEX
                    CMP STOR+2
                    BEQ START
PRINT               LDY #$00
MLOOP               LDA MESG,Y
                    BEQ WAITG
                    JSR OUTCHR
                    INY
                    BNE MLOOP
WAITG               JSR LOADOFF
                    CMP #'G
                    BNE WAITG
                    BEQ START
ADDCHK              JSR GETHEX
                    CLC
                    ADC STOR+2
                    STA STOR+2
                    BCC ADDCH1
                    INC STOR+3
ADDCH1              LDA STOR+4
                    RTS
                    
GETHEX              JSR GETNIB
GETNIB              JSR LOADON
                    CMP #$41
                    BCC NOTHI
                    SBC #$07
NOTHI               AND #$0F
                    ASL A
                    ASL A
                    ASL A
                    ASL A
                    LDY #$04
HEXROL              ROL A
                    ROL STOR+4
                    DEY
                    BNE HEXROL
                    LDA STOR+4
                    RTS
                    
LOADON
					LDA #$80
LOADOFF = *+1
					.BYTE $2C, $A9,  $00 ;BIT $00A9 FORCE NO ZERO PAGE 
                    STA $0203  ;FLAG TO ENABLE INPUT FROM SERIAL
                    JSR INCHR
                    JMP OUTCHR
                    
EXEC                LDA #$00
                    STA $0203
                    JMP (STOR+2)
MESG
					.BYTE $D,$A,$A,'OBJ CHECKSUM ERR'
					.BYTE $D,$A,'REWIND PAST ERR - TYPE G TO RESTART',0
;END